
GameOf24 = """
Let's play a game called 24. You'll be given four integers, and your objective is to use each number only once, combined with any of the four arithmetic operations (addition, subtraction, multiplication, and division) and parentheses, to achieve a total of 24. For example, if the input is 4, 7, 8, and 8, the output could be 7 * 8 - 4 * 8 = 24. You only need to find one feasible solution!
Input:
"""
CheckmateInOne = """
Given a series of chess moves written in Standard Algebraic Notation (SAN), determine the next move that will result in a checkmate.
Input: 
"""
WordSorting = """
Sort a list of words alphabetically, placing them in a single line of text separated by spaces.
Input:
"""
P3_Test = """
Given a Python function "sat", the goal is to find an input or a set of inputs that makes "sat" return "True" and then include your input inside a function called "sol()".

For example, if the function was defined like this:

```python
def sat(s: str, t:int):
    return s == "0123456789" and t==10
```

One correct final answer is:

```python
def sol():
    return "0123456789", 10
```

Now, to find a suitable input for a given "sat" function, you need to analyze the function and determine the conditions that make it return "True".
Then, put your answer inside the "sol" function with that input as the argument.
The final answer should be a self-contained, executable Python code containing only the function, similar to the example above.
DO not print the execution results in the `sol` function.
* NOTE: `sol` should not take any arguments and only return a single output, not a tuple. The output is used to feed to the first argument of `sat`, other arguments use default values.
* NOTE: `sol` should never return None, instead using assertions for edge cases.
* NOTE: do not call `sat` inside `sol`.
"""


distiller_prompt = """

As a professional and intelligent expert in information distillation, you excel at extracting essential information from user input queries into the following format. Don't give the solution, instead, focusing on how to distill the key information and thoughts of this specific problem.

Distilled Information For Solving the Problem:

1. Problem definition: analysis specific that are the key information to solve the problem.

2. Details of the problem: details of the information, analyze for each move.
"""
# {difficuties}

general_code_template = """
1. Analysis:
- step ..., if ..., then ...
- step ..., if ..., then ...
...

2. FINAL ANSWER:
...
"""

#It should be noted that you should provide 2 different ways of writing python codes to solve the same problem.
#Each code should be within one code block. You should provide two code blocks within ```python``` blocks.
instantiation_prompt = """
You are an expert in problem analysis and can apply previous problem-solving approaches to new issues.
The user will provide a specific task description and a thought template. Your goal is to analyze the user's task and generate a specific solution based on the thought template.

Provide justifications on why this is a checkmate in one. Do provide all possible defense of the opposite and explain why that move cannot defense the checkmate.
The answer of the checkmate move should be in SAN format and shown after the line "FINAL ANSWER:"

Output format

1. Analysis: here is the analysis of each step.
2. FINAL ANSWER: here is the direct answer without any other explanations
"""
# {format}
# {verification}

#Please analyze the above user task description and thought template, and generate two piece of code inside TWO separate ```python``` blocks, each block should contain the function definition of `sol`. DO NOT use `sat` function in `sol`.
combined_input_template = """
Distilled information:
{distilled_question}

User Input:
{question}

Thought template:
{template}

Instantiated Solution:
Please analyze the above user task description and thought template, and generate the analysis of the why it is a checkmate in one.
and output strictly in the below format

1. Analysis: here is the analysis of each step
2. FINAL ANSWER: here is the direct answer without any other explanations
"""
# repeat
# {format}
# {verification}

generate_debug_distiller = """
As a professional and intelligent expert in information distillation, you excel at extracting essential information from user input queries into the following format. Don't give the solution, instead, focusing on how to distill the key information and thoughts of this specific problem.

The user has made an attempt to solve the problem with some analysis, but there might be some errors inside it, help find the errors and analyze it. give concrete and concise analysis.

Answer in the following format.

Distilled Information For Solving the Problem:

1. Original question:

2. Details of the probelm: user's analysis to the problem.

3. Previous Solution:

4. Errors: whether the solution is correct or not, if not, show the concrete error concisely about user's attempt and analysis.

5. Is there an Error?:
YES/NO/UNSURE

"""
# {problem difficulty}
# {error analysis}

debug_prompt = "User Question:\n{question}\n\nDistilled Question:\n{distilled_question}\n\nPrevious Solution:\n{code}\n\nNote to tell me whether there is an error in the provided previous solution [YES/NO/UNSURE]"

answer_selection = """You are a professional problem solver, help select an answer from candidates for the user's questions, the answer is behind the line "FINAL ANSWER:". e.g.

FINAL ANSWER:
...
"""
answer_selection_prompt = "User Question:\n{question}\n\nCandidate Answers:\n{candidates}\n\nSelect one answer from the candidates, and give the final answer:"