
GameOf24 = """
Let's play a game called 24. You'll be given four integers, and your objective is to use each number only once, combined with any of the four arithmetic operations (addition, subtraction, multiplication, and division) and parentheses, to achieve a total of 24. For example, if the input is 4, 7, 8, and 8, the output could be 7 * 8 - 4 * 8 = 24. You only need to find one feasible solution!
Input:
"""
CheckmateInOne = """
Given a series of chess moves written in Standard Algebraic Notation (SAN), determine the next move that will result in a checkmate.
Input: 
"""
WordSorting = """
Sort a list of words alphabetically, placing them in a single line of text separated by spaces.
Input:
"""
P3_Test = """
Given a Python function "sat", the goal is to find an input or a set of inputs that makes "sat" return "True" and then include your input inside a function called "sol()".

For example, if the function was defined like this:

```python
def sat(s: str, t:int):
    return s == "0123456789" and t==10
```

One correct final answer is:

```python
def sol():
    return "0123456789", 10
```

Now, to find a suitable input for a given "sat" function, you need to analyze the function and determine the conditions that make it return "True".
Then, put your answer inside the "sol" function with that input as the argument.
The final answer should be a self-contained, executable Python code containing only the function, similar to the example above.
DO not print the execution results in the `sol` function.
* NOTE: `sol` should not take any arguments and only return a single output, not a tuple. The output is used to feed to the first argument of `sat`, other arguments use default values.
* NOTE: `sol` should never return None, instead using assertions for edge cases.
* NOTE: do not call `sat` inside `sol`.
"""


distiller_prompt = """

As a professional and intelligent expert in information distillation, you excel at extracting essential information from user input queries into the following format. Don't give the solution, instead, focusing on how to distill the key information and thoughts of this specific problem.

Distilled Information For Solving the Problem:

1. Problem definition: analysis specific that are the key information to solve the problem.

2. Details of the problem: details of the information, analyze for each move.
"""
# {difficuties}

general_code_template = """
1. Analysis:
- step ..., if ..., then ...
- step ..., if ..., then ...
...

2. FINAL ANSWER:
...
"""

#It should be noted that you should provide 2 different ways of writing python codes to solve the same problem.
#Each code should be within one code block. You should provide two code blocks within ```python``` blocks.
instantiation_prompt0 = """
You are an expert in problem analysis and can apply previous problem-solving approaches to new issues.
The user will provide a specific task description.
Your goal is to analyze the user's task and generate a specific solution.

SAN (Standard Algebraic Notation)
Here's how the notation works:
- The letters K, Q, R, B, N, and P represent the pieces: King, Queen, Rook, Bishop, Knight, and Pawn.
- The file (vertical column) is labeled a-h, and the rank (horizontal row) is labeled 1-8.
- Moves are written with the piece's symbol followed by the square it moves to (e.g., Nf3 means the Knight moves to f3).
- A capture is indicated by an "x" (e.g., Nxe4 means the Knight captures on e4).
- Castling is written as O-O (kingside) or O-O-O (queenside).
- Check is indicated with a "+" (e.g., Bb4+).
- If a pawn moves without capturing, the notation just lists the square it moves to (e.g., e4).

FEN (Forsyth-Edwards Notation)
A FEN string is composed of six fields, each separated by a space:

- Piece placement: This part represents the positions of pieces on the board, starting from the top rank (rank 8) and moving down to rank 1. Each piece is represented by a letter: uppercase for White pieces (P, N, B, R, Q, K) and lowercase for Black pieces (p, n, b, r, q, k). Numbers represent consecutive empty squares.
- Active color: A single character w or b indicates which side is to move (White or Black).
- Castling availability: This shows the castling rights. It uses K (White kingside), Q (White queenside), k (Black kingside), and q (Black queenside). If no castling is possible, it's marked as -.
- En passant target square: If a pawn has just made a two-square move, this records the square that can be captured via en passant; otherwise, it's -.
- Halfmove clock: The number of halfmoves since the last capture or pawn move (used for the fifty-move rule).
- Fullmove number: The number of the full move, which starts at 1 and increments after Black's move.

Here is an example of SAN to FEN:

SAN: 1. d4 d5
FEN: rnbqkbnr/ppp1pppp/8/3p4/3P4/8/PPP1PPPP/RNBQKBNR w KQkq - 0 2


Generate FEN of each SAN move in a list step by step and justify whether a given SAN move will result in checkmate.
"""
# {format}
# {verification}
instantiation_prompt = """
You are an expert in problem analysis and can apply previous problem-solving approaches to new issues.
The user will provide a specific task description.
Your goal is to analyze the user's task and generate a specific solution.

using SAN (Standard Algebraic Notation) and FEN (Forsyth-Edwards Notation) to solve the problem.

Given a starting FEN and an SAN move from it. Show the final FEN in the following form:

FEN:
...
"""

#Please analyze the above user task description and thought template, and generate two piece of code inside TWO separate ```python``` blocks, each block should contain the function definition of `sol`. DO NOT use `sat` function in `sol`.
combined_input_template = """
FEN:
{fen}

SAN move:
{san}

Now is {turn}'s turn.

Give the resulting FEN.
"""
# repeat
# {format}
# {verification}

generate_debug_distiller = """
As a professional and intelligent expert in information distillation, you excel at extracting essential information from user input queries into the following format. Don't give the solution, instead, focusing on how to distill the key information and thoughts of this specific problem.

The user has made an attempt to solve the problem with some analysis, but there might be some errors inside it, help find the errors and analyze it. give concrete and concise analysis.

Answer in the following format.

Distilled Information For Solving the Problem:

1. Original question:

2. Details of the probelm: user's analysis to the problem.

3. Previous Solution:

4. Errors: whether the solution is correct or not, if not, show the concrete error concisely about user's attempt and analysis.

5. Is there an Error?:
YES/NO/UNSURE

"""
# {problem difficulty}
# {error analysis}

debug_prompt = "User Question:\n{question}\n\nDistilled Question:\n{distilled_question}\n\nPrevious Solution:\n{code}\n\nNote to tell me whether there is an error in the provided previous solution [YES/NO/UNSURE]"

answer_selection = """You are a professional problem solver, help select an answer from candidates for the user's questions, the answer is behind the line "FINAL ANSWER:". e.g.

FINAL ANSWER:
...
"""
answer_selection_prompt = "User Question:\n{question}\n\nCandidate Answers:\n{candidates}\n\nSelect one answer from the candidates, and give the final answer:"