
GameOf24 = """
Let's play a game called 24. You'll be given four integers, and your objective is to use each number only once, combined with any of the four arithmetic operations (addition, subtraction, multiplication, and division) and parentheses, to achieve a total of 24. For example, if the input is 4, 7, 8, and 8, the output could be Answer:\n7 * 8 - 4 * 8\nYou only need to find one feasible solution!
Input:
"""
CheckmateInOne = """
Given a series of chess moves written in Standard Algebraic Notation (SAN), determine the next move that will result in a checkmate.
Input: 
"""
WordSorting = """
Sort a list of words alphabetically, placing them in a single line of text separated by spaces.
Input:
"""
P3_Test = """
Given a Python function "sat", the goal is to find an input or a set of inputs that makes "sat" return "True" and then include your input inside a function called "sol()".

For example, if the function was defined like this:

```python
def sat(s: str, t:int):
    return s == "0123456789" and t==10
```

One correct final answer is:

```python
def sol():
    return "0123456789", 10
```

Now, to find a suitable input for a given "sat" function, you need to analyze the function and determine the conditions that make it return "True".
Then, put your answer inside the "sol" function with that input as the argument.
The final answer should be a self-contained, executable Python code containing only the function, similar to the example above.
DO not print the execution results in the `sol` function.
* NOTE: `sol` should not take any arguments and only return a single output, not a tuple. The output is used to feed to the first argument of `sat`, other arguments use default values.
* NOTE: `sol` should never return None, instead using assertions for edge cases.
* NOTE: do not call `sat` inside `sol`.
"""


distiller = """

As a professional and intelligent expert in information distillation, you excel at extracting essential information from user input queries and an answer template into the following format. Don't give the solution, instead, focusing on how to distill the key information and thoughts of this specific problem.

Distilled Information For Solving the Problem:

1. Problem definition: define what problem is this.

2. Problem description: describe the problem in a clearer and concise way. Include all necessary information here.

3. Input and output: what is the input to this problem? what is the expected output type?

4. Difficulty: what potential problem could the Problem Solver have? Describe the difficulty specific to the problem input, not in a general way, because the Problem Solver is smart and only need concrete suggestions.

"""

general_code_template = """
Answer:
3 * 8 + 1 - 1

Answer:
(6 + 3) * 3 - 3
"""

#It should be noted that you should provide 2 different ways of writing python codes to solve the same problem.
#Each code should be within one code block. You should provide two code blocks within ```python``` blocks.
problem_solver = """
You are an expert in problem analysis and can apply previous problem-solving approaches to new issues.
The user will provide a specific task description. Your goal is to analyze the user's task and generate a specific solution in the format of an answer template.

Make sure to evaluate each step of the analysis.
"""

#Please analyze the above user task description and thought template, and generate two piece of code inside TWO separate ```python``` blocks, each block should contain the function definition of `sol`. DO NOT use `sat` function in `sol`.
problem_solver_prompt = """
User Input:
{question}

Distilled Question:
{distlled_question}

Anwer Template:
{template}

Instantiated Solution:
Please analyze the above user task description, and generate step by step evaluations. At the end give the answer in the specified format.
"""

evaluator = """
As a professional and intelligent evaluator, you strictly evaluate whether user's output correctly answer the user's problem.
Solving the problem is different from evaluating the solution.
Your goal is not to solve the user's problem, instead, from an evaluator's perspective, give a different point of view about the give solutions and the given problem description.
"""

evaluator_prompt = """
User Question:
{question}

A Solution and Analysis:
{solution}

Given the above user question and the above solution description, strictly evaluate whether the question is correctly answered by the solution.

Return your evaluation after the special field name "Correctness: " at the end of your answer, with the values "YES/NO". for example:

Correctness: YES
"""

eval_distiller = """
As a professional and intelligent information distiller, you are perfect at reading two people's report and generate the problem detail descriptions.
The two persons are a problem solver and a evaluator.
The evaluator stated that the problem solver get an error in his solution.

Now give the user distilled information of this problem solving based on 1. problem description, 2. problem solver's solution, 3. evaluator's error description

Distilled Information of the Problem Solving:

1. Problem definition: analysis specific that are the key information to solve the problem.

2. Details of the problem: details of the information, analysis.

3. Difficulty: Analyze the difficulty of the problem using the details of the problem, what potential problem could the problem have? Give the difficulty detail and specific to the user's specific question.

4. Problem solver's solution:

5. Evaluator's error description:

"""

eval_distiller_prompt = """
Problem Description:
{distilled_question}

Problem solver's solution:
{code}

Evaluator's error description:
{err_msg}
"""

final_evaluator = """
You are a evaluator who is good at reasoning and math.

Given a question and a solution to this problem, please verify whether this solution solves the problem 100 percent correctly.

just give the result in two of the following options:

EVAL: CORRECT

or

EVAL: WRONG
"""

final_evaluator_prompt = """
User's question:
{question}

Problem Solver's solution:
{distilled_answer}
"""